﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TextFormat
{
    internal class Menu
    {
        List<Customer> customers;
        List<Book> books;
        public Menu()
        {

            customers = new List<Customer>();
            books = new List<Book>();
        }

        public void UserMenu()
        {
            int chooseAction;
            bool flag = true;
            while (flag)
            {
                while (true)
                {
                    try
                    {
                        try
                        {
                            Console.WriteLine("Выберете действие\n" +
                            "1 - Добавить запись\n" +
                            "2 - Показать записи\n" +
                            "3 - Считать файл\n" +
                            "4 - Записать в файл\n" +
                            "5 - Сортировка\n" +
                            "0 - Завершить\n");
                            chooseAction = Convert.ToInt32(Console.ReadLine());
                            if (chooseAction > 5)
                                throw new Exception();
                            else
                                break;
                        }
                        catch (Exception ex)
                        {
                            Console.WriteLine("Введите число от 0 до 5");
                        }

                    }
                    catch (Exception e)
                    {
                        Console.WriteLine("Введите число от 0 до 5");
                    }
                }
                
                switch (chooseAction)
                {
                    case 1:
                        bool add = true;
                        while (add)
                        {
                            add = AddRecord();
                        }
                        break;
                    case 2:
                        ShowModel();                        
                        break;
                    case 3:
                        ReadingFile();
                        break;
                    case 4:
                        WriteFile();
                        break;
                    case 5:
                        SortedList();
                        break;
                    default:
                        flag = false;
                        break;
                }
            }
        }


        private void SortedList()
        {
            int chooseTypeSorted;
            while (true)
            {
                try
                {
                    try
                    {
                        Console.WriteLine("Выберете тип сортировки:\n" +
                        "1 - По возрастанию\n" +
                        "2 - По убыванию\n" +
                        "0 - Назад\n");
                        chooseTypeSorted = Convert.ToInt32(Console.ReadLine());
                        if (chooseTypeSorted > 2)
                            throw new Exception();
                        else
                            break;
                    }
                    catch (Exception ex)
                    {
                        Console.WriteLine("Введите число от 0 до 2");
                    }

                }
                catch (Exception e)
                {
                    Console.WriteLine("Введите число от 0 до 2");
                }
            }
            switch(chooseTypeSorted)
            {
                case 1:
                    int chooseModelSorted;
                    while (true)
                    {
                        try
                        {
                            try
                            {
                                Console.WriteLine("Выберете модель:\n" +
                                "1 - Сотрудник\n" +
                                "2 - Книга\n" +
                                "0 - Назад\n");
                                chooseModelSorted = Convert.ToInt32(Console.ReadLine());
                                if (chooseModelSorted > 2)
                                    throw new Exception();
                                else
                                    break;
                            }
                            catch (Exception ex)
                            {
                                Console.WriteLine("Введите число от 0 до 2");
                            }

                        }
                        catch (Exception e)
                        {
                            Console.WriteLine("Введите число от 0 до 2");
                        }
                    }
                    switch (chooseModelSorted)
                    {

                        case 1:
                            int chooseSortedFieldCust;
                            while (true)
                            {
                                try
                                {
                                    try
                                    {
                                        Console.WriteLine("Выберете поле для сортировки:\n" +
                                        "1 - Фамилия\n" +
                                        "2 - Имя\n" +
                                        "3 - Отчество\n" +
                                        "4 - Дата рождения\n" +
                                        "0 - Назад\n");
                                        chooseSortedFieldCust = Convert.ToInt32(Console.ReadLine());
                                        if (chooseSortedFieldCust > 4)
                                            throw new Exception();
                                        else
                                            break;
                                    }
                                    catch (Exception ex)
                                    {
                                        Console.WriteLine("Введите число от 0 до 4");
                                    }

                                }
                                catch (Exception e)
                                {
                                    Console.WriteLine("Введите число от 0 до 4");
                                }
                            }
                            switch (chooseSortedFieldCust)
                            {
                                case 1:
                                    customers = customers.OrderBy(x => x.Surname).ToList();
                                    Console.WriteLine("Данные отсортированы");

                                    break;
                                case 2:
                                    customers = customers.OrderBy(x => x.Name).ToList();
                                    Console.WriteLine("Данные отсортированы");

                                    break;
                                case 3:
                                    customers = customers.OrderBy(x => x.Patronymic).ToList();
                                    Console.WriteLine("Данные отсортированы");

                                    break;
                                case 4:
                                    customers = customers.OrderBy(x => x.DateOfBirth).ToList();
                                    Console.WriteLine("Данные отсортированы");
                                    break;
                                default:
                                    break;
                            }
                            break;
                        case 2:
                            int chooseSortedFieldBook;
                            while (true)
                            {
                                try
                                {
                                    try
                                    {
                                        Console.WriteLine("Выберете поле для сортировки:\n" +
                                        "1 - Название\n" +
                                        "2 - Автор\n" +
                                        "3 - Жанр\n" +
                                        "4 - Дата выпуска\n" +
                                        "0 - Назад\n");
                                        chooseSortedFieldBook = Convert.ToInt32(Console.ReadLine());
                                        if (chooseSortedFieldBook > 4)
                                            throw new Exception();
                                        else
                                            break;
                                    }
                                    catch (Exception ex)
                                    {
                                        Console.WriteLine("Введите число от 0 до 4");
                                    }

                                }
                                catch (Exception e)
                                {
                                    Console.WriteLine("Введите число от 0 до 4");
                                }
                            }
                            switch (chooseSortedFieldBook)
                            {
                                case 1:
                                    books = books.OrderBy(x => x.Title).ToList();
                                    Console.WriteLine("Данные отсортированы");

                                    break;
                                case 2:
                                    books = books.OrderBy(x => x.Author).ToList();
                                    Console.WriteLine("Данные отсортированы");

                                    break;
                                case 3:
                                    books = books.OrderBy(x => x.Genre).ToList();
                                    Console.WriteLine("Данные отсортированы");

                                    break;
                                case 4:
                                    books = books.OrderBy(x => x.ReleaseDate).ToList();
                                    Console.WriteLine("Данные отсортированы");

                                    break;
                                default:
                                    break;
                            }
                            break;
                        default:
                            break;
                    }
                    break;
                case 2:
                    int chooseModelSortedDesc;
                    while (true)
                    {
                        try
                        {
                            try
                            {
                                Console.WriteLine("Выберете модель:\n" +
                                "1 - Сотрудник\n" +
                                "2 - Книга\n" +
                                "0 - Назад\n");
                                chooseModelSortedDesc = Convert.ToInt32(Console.ReadLine());
                                if (chooseModelSortedDesc > 2)
                                    throw new Exception();
                                else
                                    break;
                            }
                            catch (Exception ex)
                            {
                                Console.WriteLine("Введите число от 0 до 2");
                            }

                        }
                        catch (Exception e)
                        {
                            Console.WriteLine("Введите число от 0 до 2");
                        }
                    }

                    switch (chooseModelSortedDesc)
                    {

                        case 1:
                            int chooseSortedFieldCust;
                            while (true)
                            {
                                try
                                {
                                    try
                                    {
                                        Console.WriteLine("Выберете поле для сортировки:\n" +
                                        "1 - Фамилия\n" +
                                        "2 - Имя\n" +
                                        "3 - Отчество\n" +
                                        "4 - Дата рождения\n" +
                                        "0 - Назад\n");
                                        chooseSortedFieldCust = Convert.ToInt32(Console.ReadLine());
                                        if (chooseSortedFieldCust > 4)
                                            throw new Exception();
                                        else
                                            break;
                                    }
                                    catch (Exception ex)
                                    {
                                        Console.WriteLine("Введите число от 0 до 4");
                                    }

                                }
                                catch (Exception e)
                                {
                                    Console.WriteLine("Введите число от 0 до 4");
                                }
                            }
                            switch (chooseSortedFieldCust)
                            {
                                case 1:
                                    customers = customers.OrderByDescending(x => x.Surname).ToList();
                                    Console.WriteLine("Данные отсортированы");

                                    break;
                                case 2:
                                    customers = customers.OrderByDescending(x => x.Name).ToList();
                                    Console.WriteLine("Данные отсортированы");

                                    break;
                                case 3:
                                    customers = customers.OrderByDescending(x => x.Patronymic).ToList();
                                    Console.WriteLine("Данные отсортированы");

                                    break;
                                case 4:
                                    customers = customers.OrderByDescending(x => x.DateOfBirth).ToList();
                                    Console.WriteLine("Данные отсортированы");
                                    break;
                                default:
                                    break;
                            }
                            break;
                        case 2:
                            int chooseSortedFieldBook;
                            while (true)
                            {
                                try
                                {
                                    try
                                    {
                                        Console.WriteLine("Выберете поле для сортировки:\n" +
                                        "1 - Название\n" +
                                        "2 - Автор\n" +
                                        "3 - Жанр\n" +
                                        "4 - Дата выпуска\n" +
                                        "0 - Назад\n");
                                        chooseSortedFieldBook = Convert.ToInt32(Console.ReadLine());
                                        if (chooseSortedFieldBook > 4)
                                            throw new Exception();
                                        else
                                            break;
                                    }
                                    catch (Exception ex)
                                    {
                                        Console.WriteLine("Введите число от 0 до 4");
                                    }

                                }
                                catch (Exception e)
                                {
                                    Console.WriteLine("Введите число от 0 до 4");
                                }
                            }
                            switch (chooseSortedFieldBook)
                            {
                                case 1:
                                    books = books.OrderByDescending(x => x.Title).ToList();
                                    Console.WriteLine("Данные отсортированы");

                                    break;
                                case 2:
                                    books = books.OrderByDescending(x => x.Author).ToList();
                                    Console.WriteLine("Данные отсортированы");

                                    break;
                                case 3:
                                    books = books.OrderByDescending(x => x.Genre).ToList();
                                    Console.WriteLine("Данные отсортированы");

                                    break;
                                case 4:
                                    books = books.OrderByDescending(x => x.ReleaseDate).ToList();
                                    Console.WriteLine("Данные отсортированы");

                                    break;
                                default:
                                    break;
                            }
                            break;
                        default:
                            break;
                    }
                    break;
                default:
                    break;
                    
            }

        }
        private void WriteFile()
        {
            int chooseModelReading = 0;
            while (true)
            {
                try
                {
                    try
                    {
                        Console.WriteLine("Выберете модель:\n" +
                        "1 - Сотрудник\n" +
                        "2 - Книга\n" +
                        "0 - Назад\n");
                        chooseModelReading = Convert.ToInt32(Console.ReadLine());
                        if (chooseModelReading > 2)
                            throw new Exception();
                        else
                            break;
                    }
                    catch (Exception ex)
                    {
                        Console.WriteLine("Введите число от 0 до 2");
                    }

                }
                catch (Exception e)
                {
                    Console.WriteLine("Введите число от 0 до 2");
                }
            }
            IFileProcessor fileProcessor;

            switch (chooseModelReading)
            {

                case 1:
                    int chooseModelWrittingFormatCust;
                    while (true)
                    {
                        try
                        {
                            try
                            {
                                Console.WriteLine("Выберете формат файла:\n" +
                                "1 - CSV\n" +
                                "2 - XML\n" +
                                "3 - JSON\n" +
                                "4 - YAML\n" +
                                "0 - Назад\n");
                                chooseModelWrittingFormatCust = Convert.ToInt32(Console.ReadLine());
                                if (chooseModelWrittingFormatCust > 4)
                                    throw new Exception();
                                else
                                    break;
                            }
                            catch (Exception ex)
                            {
                                Console.WriteLine("Введите число от 0 до 4");
                            }

                        }
                        catch (Exception e)
                        {
                            Console.WriteLine("Введите число от 0 до 4");
                        }
                    }
                    string fileName;
                    switch (chooseModelWrittingFormatCust)
                    {
                        case 1:
                            Console.WriteLine("Введите название файла: ");
                            fileName = Console.ReadLine();
                            fileProcessor = new CSVClass<Customer>();
                            fileProcessor.WriteFile<Customer>(customers,fileName);
                            
                            break;
                        case 2:
                            Console.WriteLine("Введите название файла: ");
                            fileName = Console.ReadLine();
                            fileProcessor = new XMLClass<Customer>();
                            fileProcessor.WriteFile<Customer>(customers,fileName);
                            
                            break;
                        case 3:
                            Console.WriteLine("Введите название файла: ");
                            fileName = Console.ReadLine();
                            fileProcessor = new JsonClass<Customer>();
                            fileProcessor.WriteFile<Customer>(customers, fileName);
                            
                            break;
                        case 4:
                            Console.WriteLine("Введите название файла: ");
                            fileName = Console.ReadLine();
                            fileProcessor = new YAMLClass<Customer>();
                            fileProcessor.WriteFile<Customer>(customers, fileName);
                            
                            break;
                        default:
                            break;
                    }
                    break;
                case 2:
                    int chooseModelWrittingFormatBook;
                    while (true)
                    {
                        try
                        {
                            try
                            {
                                Console.WriteLine("Выберете формат файла:\n" +
                                "1 - CSV\n" +
                                "2 - XML\n" +
                                "3 - JSON\n" +
                                "4 - YAML\n" +
                                "0 - Назад\n");
                                chooseModelWrittingFormatBook = Convert.ToInt32(Console.ReadLine());
                                if (chooseModelWrittingFormatBook > 4)
                                    throw new Exception();
                                else
                                    break;
                            }
                            catch (Exception ex)
                            {
                                Console.WriteLine("Введите число от 0 до 4");
                            }

                        }
                        catch (Exception e)
                        {
                            Console.WriteLine("Введите число от 0 до 4");
                        }
                    }
                    string fileNameBook;
                    switch (chooseModelWrittingFormatBook)
                    {
                        case 1:
                            Console.WriteLine("Введите название файла: ");
                            fileNameBook = Console.ReadLine();
                            fileProcessor = new CSVClass<Book>();
                            fileProcessor.WriteFile<Book>(books,fileNameBook);
                            
                            break;
                        case 2:
                            Console.WriteLine("Введите название файла: ");
                            fileNameBook = Console.ReadLine();
                            fileProcessor = new XMLClass<Book>();
                            fileProcessor.WriteFile<Book>(books, fileNameBook);
                            
                            break;
                        case 3:
                            Console.WriteLine("Введите название файла: ");
                            fileNameBook = Console.ReadLine();
                            fileProcessor = new JsonClass<Book>();
                            fileProcessor.WriteFile<Book>(books, fileNameBook);
                            
                            break;
                        case 4:
                            Console.WriteLine("Введите название файла: ");
                            fileNameBook = Console.ReadLine();
                            fileProcessor = new YAMLClass<Book>();
                            fileProcessor.WriteFile<Book>(books, fileNameBook);
                            
                            break;
                        default:
                            break;
                    }
                    break;
                default:
                    break;
            }
        }
        private void ReadingFile()
        {
            int chooseModelReading = 0;
            while (true)
            {
                try
                {
                    try
                    {
                        Console.WriteLine("Выберете модель:\n" +
                        "1 - Сотрудник\n" +
                        "2 - Книга\n" +
                        "0 - Назад\n");
                        chooseModelReading = Convert.ToInt32(Console.ReadLine());
                        if (chooseModelReading > 2)
                            throw new Exception();
                        else
                            break;
                    }
                    catch (Exception ex)
                    {
                        Console.WriteLine("Введите число от 0 до 2");
                    }

                }
                catch (Exception e)
                {
                    Console.WriteLine("Введите число от 0 до 2");
                }
            }
            IFileProcessor fileProcessor;

            switch (chooseModelReading)
            {
                
                case 1:
                    int chooseModelReadingFormatCust;
                    while (true)
                    {
                        try
                        {
                            try
                            {
                                Console.WriteLine("Выберете формат файла:\n" +
                                "1 - CSV\n" +
                                "2 - XML\n" +
                                "3 - JSON\n" +
                                "4 - YAML\n" +
                                "0 - Назад\n");
                                chooseModelReadingFormatCust = Convert.ToInt32(Console.ReadLine());
                                if (chooseModelReadingFormatCust > 4)
                                    throw new Exception();
                                else
                                    break;
                            }
                            catch (Exception ex)
                            {
                                Console.WriteLine("Введите число от 0 до 4");
                            }

                        }
                        catch (Exception e)
                        {
                            Console.WriteLine("Введите число от 0 до 4");
                        }
                    }
                    string fileName;
                    switch (chooseModelReadingFormatCust)
                    {
                        case 1:
                            Console.WriteLine("Введите название файла: ");
                            fileName = Console.ReadLine();
                            fileProcessor = new CSVClass<Customer>();
                            customers = fileProcessor.ReadFile<Customer>(fileName);
                            break;
                        case 2:
                            Console.WriteLine("Введите название файла: ");
                            fileName = Console.ReadLine();
                            fileProcessor = new XMLClass<Customer>();
                            customers = fileProcessor.ReadFile<Customer>(fileName);
                            break;
                        case 3:
                            Console.WriteLine("Введите название файла: ");
                            fileName = Console.ReadLine();
                            fileProcessor = new JsonClass<Customer>();
                            customers = fileProcessor.ReadFile<Customer>(fileName);
                            break;
                        case 4:
                            Console.WriteLine("Введите название файла: ");
                            fileName = Console.ReadLine();
                            fileProcessor = new YAMLClass<Customer>();
                            customers = fileProcessor.ReadFile<Customer>(fileName);
                            
                            break;
                        default:
                            break;
                    }
                    break;
                case 2:
                    int chooseModelReadingFormatBook;
                    while (true)
                    {
                        try
                        {
                            try
                            {
                                Console.WriteLine("Выберете формат файла:\n" +
                                "1 - CSV\n" +
                                "2 - XML\n" +
                                "3 - JSON\n" +
                                "4 - YAML\n" +
                                "0 - Назад\n");
                                chooseModelReadingFormatBook = Convert.ToInt32(Console.ReadLine());
                                if (chooseModelReadingFormatBook > 4)
                                    throw new Exception();
                                else
                                    break;
                            }
                            catch (Exception ex)
                            {
                                Console.WriteLine("Введите число от 0 до 4");
                            }

                        }
                        catch (Exception e)
                        {
                            Console.WriteLine("Введите число от 0 до 4");
                        }
                    }
                    string fileNameBook;
                    switch (chooseModelReadingFormatBook)
                    {
                        case 1:
                            Console.WriteLine("Введите название файла: ");
                            fileNameBook = Console.ReadLine();
                            fileProcessor = new CSVClass<Book>();
                            books = fileProcessor.ReadFile<Book>(fileNameBook);
                            
                            break;
                        case 2:
                            Console.WriteLine("Введите название файла: ");
                            fileNameBook = Console.ReadLine();
                            fileProcessor = new XMLClass<Book>();
                            books = fileProcessor.ReadFile<Book>(fileNameBook);
                            
                            break;
                        case 3:
                            Console.WriteLine("Введите название файла: ");
                            fileNameBook = Console.ReadLine();
                            fileProcessor = new JsonClass<Book>();
                            books = fileProcessor.ReadFile<Book>(fileNameBook);
                            
                            break;
                        case 4:
                            Console.WriteLine("Введите название файла: ");
                            fileNameBook = Console.ReadLine();
                            fileProcessor = new YAMLClass<Book>();
                            books = fileProcessor.ReadFile<Book>(fileNameBook);
                            
                            break;
                        default:
                            break;
                    }
                    break;
                default:
                    break;
            }

        }
        private void ShowModel()
        {
            int chooseModelShow= 0;
            while (true)
            {
                try
                {
                    try
                    {
                        Console.WriteLine("Выберете модель:\n" +
                        "1 - Сотрудник\n" +
                        "2 - Книга\n");
                        chooseModelShow = Convert.ToInt32(Console.ReadLine());
                        if (chooseModelShow > 2)
                            throw new Exception();
                        else
                            break;
                    }
                    catch (Exception ex)
                    {
                        Console.WriteLine("Введите число от 0 до 2");
                    }

                }
                catch (Exception e)
                {
                    Console.WriteLine("Введите число от 0 до 2");
                }
            }
                
                
            switch (chooseModelShow)
            {
                case 1:
                    if (customers.Count > 0)
                    {
                        foreach (var i in customers)
                        {
                            Console.WriteLine(i);
                        }
                    }
                    else
                    {
                        Console.WriteLine("Записи отсутствуют");
                    }
                    break;
                case 2:
                    if (books.Count > 0)
                    {
                        foreach (var i in books)
                        {
                            Console.WriteLine(i);
                        }
                    }
                    else
                    {
                        Console.WriteLine("Записи отсутствуют");
                    }
                    break;
                default:
                    break;
            }
        }
        private bool AddRecord()
        {
            int chooseModelAdd = 0;
            while (true)
            {
                try
                {
                    try
                    {
                        Console.WriteLine("Выберете модель:\n" +
                               "1 - Сотрудник\n" +
                               "2 - Книга\n" +
                               "0 - Назад\n");
                        chooseModelAdd = Convert.ToInt32(Console.ReadLine());
                        if (chooseModelAdd > 2)
                            throw new Exception();
                        else
                            break;
                    }
                    catch (Exception ex)
                    {
                        Console.WriteLine("Введите число от 0 до 2");
                    }

                }
                catch (Exception e)
                {
                    Console.WriteLine("Введите число от 0 до 2");
                }
            }
            bool flag = true;
           

            switch (chooseModelAdd)
            {
                case 1:
                    Console.WriteLine("Фамилия: ");
                    string surname = Console.ReadLine();
                    Console.WriteLine("Имя: ");
                    string name = Console.ReadLine();
                    Console.WriteLine("Отчество: ");
                    string patronymic = Console.ReadLine();
                    Console.WriteLine("Дата рождения: ");
                    while (true)
                    {
                        try
                        {

                            DateTime dateOfBirth = Convert.ToDateTime(Console.ReadLine());
                            try
                            {
                                customers.Add(new Customer() { Surname = surname, Name = name, Patronymic = patronymic, DateOfBirth = dateOfBirth });
                                Console.WriteLine("\nЗапись успешно добавлена");
                                flag = false;
                                break;
                            }
                            catch (Exception e)
                            {
                                Console.WriteLine("Не удалось добавить запись.");
                                break;
                            }

                        }
                        catch (Exception ex)
                        {
                            Console.WriteLine("Не удалось распознать дату");
                        }

                    }
                    break;
                case 2:
                    Console.WriteLine("Название: ");
                    string title = Console.ReadLine();
                    Console.WriteLine("Автор: ");
                    string author = Console.ReadLine();
                    Console.WriteLine("Жанр: ");
                    string genre = Console.ReadLine();
                    Console.WriteLine("Дата выпуска: ");
                    while (true)
                    {
                        try
                        {
                            DateTime dateRelease = Convert.ToDateTime(Console.ReadLine());
                            try
                            {
                                books.Add(new Book() { Title = title, Author = author, Genre = genre, ReleaseDate = dateRelease });
                                Console.WriteLine("\nЗапись успешно добавлена");
                                flag = false;
                                break;
                            }
                            catch (Exception e)
                            {
                                Console.WriteLine("Не удалось добавить запись.");
                                break;
                            }
                        }
                        catch (Exception ex)
                        {
                            Console.WriteLine("Не удалось распознать дату");
                        }

                    }
                    break;
                default:
                    flag = false;
                    break;
            }

            return flag;

        }
    }
}
